Index: vi/vs_line.c
Prereq: 	10.19 
*** nvi-1.79/vi/vs_line.c	Fri Sep 27 11:55:47 1996
--- nvi-1.79-m17n/vi/vs_line.c	Fri Feb 21 22:23:19 1997
***************
*** 49,57 ****
--- 49,65 ----
  	size_t chlen, cno_cnt, cols_per_screen, len, nlen;
  	size_t offset_in_char, offset_in_line, oldx, oldy;
  	size_t scno, skip_cols, skip_screens;
+ #ifdef MULTIBYTE
+ 	/* XXX why ch has to be int? */
+ #endif
  	int ch, dne, is_cached, is_partial, is_tab;
  	int list_tab, list_dollar;
  	char *p, *cbp, *ecbp, cbuf[128];
+ #ifdef MULTIBYTE
+ 	CHAR_T *p0;
+ 	CHAR_T *pch;
+ 	int fakeeol;
+ #endif /*MULTIBYTE*/
  
  #if defined(DEBUG) && 0
  	TRACE(sp, "vs_line: row %u: line: %u off: %u\n",
***************
*** 92,97 ****
--- 100,108 ----
  
  	/* Get the line. */
  	dne = db_get(sp, smp->lno, 0, &p, &len);
+ #ifdef MULTIBYTE
+ 	p0 = p;
+ #endif
  
  	/*
  	 * Special case if we're printing the info/mode line.  Skip printing
***************
*** 235,241 ****
--- 246,257 ----
  			offset_in_line = tsmp->c_eboff;
  			offset_in_char = tsmp->c_eclen;
  		} else {
+ #ifndef MULTIBYTE
  			offset_in_line = tsmp->c_eboff + 1;
+ #else
+ 			offset_in_line = tsmp->c_eboff
+ 					+ KEY_BLEN(sp, p0[tsmp->c_eboff]);
+ #endif
  			offset_in_char = 0;
  		}
  
***************
*** 256,261 ****
--- 272,278 ----
  
  	/* Do it the hard way, for leftright scrolling screens. */
  	if (O_ISSET(sp, O_LEFTRIGHT)) {
+ #ifndef MULTIBYTE
  		for (; offset_in_line < len; ++offset_in_line) {
  			chlen = (ch = *(u_char *)p++) == '\t' && !list_tab ?
  			    TAB_OFF(scno) : KEY_LEN(sp, ch);
***************
*** 276,285 ****
--- 293,333 ----
  			smp->c_sboff = ++offset_in_line;
  			smp->c_scoff = 0;
  		}
+ #else
+ 		while (offset_in_line < len) {
+ 			ch = *(u_char *)p;
+ 			chlen = (ch == '\t' && !list_tab) ?
+ 			    TAB_OFF(scno) : KEY_LEN(sp, ch);
+ 
+ 			/* easy cases first. */
+ 			if (scno + chlen < skip_cols) {
+ 				scno += chlen;
+ 				p += KEY_BLEN(sp, ch);
+ 				offset_in_line += KEY_BLEN(sp, ch);
+ 				continue;
+ 			}
+ 
+ 			if (scno + chlen == skip_cols) {
+ 				scno += chlen;
+ 				p += KEY_BLEN(sp, ch);
+ 				offset_in_line += KEY_BLEN(sp, ch);
+ 			}
+ 		
+ 			break;
+ 		}
+ 
+ 		/* Set cols_per_screen to 2nd and later line length. */
+ 		cols_per_screen = sp->cols;
+ 
+ 		/* Put starting info for this line in the cache. */
+ 		smp->c_sboff = offset_in_line;
+ 		smp->c_scoff = offset_in_char = scno + chlen - skip_cols;
+ #endif /*MULTIBYTE*/
  	}
  
  	/* Do it the hard way, for historic line-folding screens. */
  	else {
+ #ifndef MULTIBYTE
  		for (; offset_in_line < len; ++offset_in_line) {
  			chlen = (ch = *(u_char *)p++) == '\t' && !list_tab ?
  			    TAB_OFF(scno) : KEY_LEN(sp, ch);
***************
*** 307,312 ****
--- 355,414 ----
  			smp->c_sboff = ++offset_in_line;
  			smp->c_scoff = 0;
  		}
+ #else
+ 		while (offset_in_line < len) {
+ 			ch = *(u_char *)p;
+ 			chlen = (ch == '\t' && !list_tab) ?
+ 			    TAB_OFF(scno) : KEY_LEN(sp, ch);
+ 
+ 			/* Easy case first. */
+ 			if (scno + chlen < cols_per_screen) {
+ 				scno += chlen;
+ 				p += KEY_BLEN(sp, ch);
+ 				offset_in_line += KEY_BLEN(sp, ch);
+ 				continue;
+ 			}
+ 
+ 			/*
+ 			 * Since we can't generally cross the rightmost column
+ 			 * by displaying multibyte char, we must check if
+ 			 * the to-be-displayed character crosses the rightmost
+ 			 * column or not.
+ 			 * In that case, we fake the scno so that you'll see
+ 			 * that the line was already filled up completely.
+ 			 */
+ 			if (KEY_BLEN(sp, ch) == 1
+ 			 || scno + chlen == cols_per_screen) {
+ 				scno += chlen;
+ 				p += KEY_BLEN(sp, ch);
+ 				offset_in_line += KEY_BLEN(sp, ch);
+ 			} else
+ 				scno = cols_per_screen;
+ 
+ 			scno -= cols_per_screen;
+ 
+ 			/* Set cols_per_screen to 2nd and later line length. */
+ 			cols_per_screen = sp->cols;
+ 
+ 			/*
+ 			 * If crossed the last skipped screen boundary, start
+ 			 * displaying the characters.
+ 			 */
+ 			if (--skip_screens == 0)
+ 				break;
+ 		}
+ 
+ 		/* Put starting info for this line in the cache. */
+ 		if (scno != 0) {
+ 			smp->c_sboff = offset_in_line;
+ 			smp->c_scoff = offset_in_char = chlen - scno;
+ 			offset_in_line -= multi_back(sp, p0, p);
+ 			p -= multi_back(sp, p0, p);
+ 		} else {
+ 			smp->c_sboff = offset_in_line;
+ 			smp->c_scoff = 0;
+ 		}
+ #endif /*MULTIBYTE*/
  	}
  
  display:
***************
*** 317,325 ****
  	 * Don't fill anything in unless it's the right line and the right
  	 * character, and the right part of the character...
  	 */
  	if (yp == NULL ||
  	    smp->lno != sp->lno || sp->cno < offset_in_line ||
! 	    offset_in_line + cols_per_screen < sp->cno) {
  		cno_cnt = 0;
  		/* If the line is on the screen, quit. */
  		if (is_cached)
--- 419,439 ----
  	 * Don't fill anything in unless it's the right line and the right
  	 * character, and the right part of the character...
  	 */
+ #ifndef MULTIBYTE
  	if (yp == NULL ||
  	    smp->lno != sp->lno || sp->cno < offset_in_line ||
! 	    offset_in_line + cols_per_screen < sp->cno)
! #else
! 	/*
! 	 * In multibyte environment, it is not true that every byte
! 	 * occupy at least single column.  Therefore, we can't simply
! 	 * compare offset_in_line+cols_per_screen against sp->cno.
! 	 * Do it slowly.
! 	 */
! 	if (yp == NULL ||
! 	    smp->lno != sp->lno || sp->cno < offset_in_line)
! #endif /*MULTIBYTE*/
! 	{
  		cno_cnt = 0;
  		/* If the line is on the screen, quit. */
  		if (is_cached)
***************
*** 329,337 ****
  
  	/* This is the loop that actually displays characters. */
  	ecbp = (cbp = cbuf) + sizeof(cbuf) - 1;
  	for (is_partial = 0, scno = 0;
  	    offset_in_line < len; ++offset_in_line, offset_in_char = 0) {
! 		if ((ch = *(u_char *)p++) == '\t' && !list_tab) {
  			scno += chlen = TAB_OFF(scno) - offset_in_char;
  			is_tab = 1;
  		} else {
--- 443,465 ----
  
  	/* This is the loop that actually displays characters. */
  	ecbp = (cbp = cbuf) + sizeof(cbuf) - 1;
+ #ifdef MULTIBYTE
+ 	fakeeol = 0;
+ #endif
  	for (is_partial = 0, scno = 0;
  	    offset_in_line < len; ++offset_in_line, offset_in_char = 0) {
! #ifndef MULTIBYTE
! 		if ((ch = *(u_char *)p++) == '\t' && !list_tab)
! #else
! 		ch = *(u_char *)p;
! 		pch = p;
! 		p += KEY_BLEN(sp, ch);
! 		if (1 < cno_cnt)
! 			cno_cnt -= (KEY_BLEN(sp, ch) - 1);/*subtract one later*/
! 
! 		if (ch == '\t' && !list_tab)
! #endif
! 		{
  			scno += chlen = TAB_OFF(scno) - offset_in_char;
  			is_tab = 1;
  		} else {
***************
*** 339,344 ****
--- 467,496 ----
  			is_tab = 0;
  		}
  
+ #ifdef MULTIBYTE
+ 		/*
+ 		 * Since we can't generally cross the rightmost column
+ 		 * by displaying multibyte char, we must check if
+ 		 * the to-be-displayed character crosses the rightmost
+ 		 * column or not.
+ 		 * In that case, we fake the scno so that you'll see
+ 		 * that the line was already filled up completely.
+ 		 */
+ 		if (offset_in_line + KEY_BLEN(sp, ch) < len
+ 		 && 1 < KEY_BLEN(sp, *(u_char *)p)
+ 		 && scno + KEY_LEN(sp, *(u_char *)p) > cols_per_screen) {
+ 			fakeeol++;
+ 
+ 			smp->c_ecsize = chlen;
+ 			smp->c_eclen = chlen;
+ 			is_partial = 0;
+ 
+ 			smp->c_eboff = offset_in_line + KEY_BLEN(sp, ch) - 1;
+ 
+ 			/* Terminate the loop. */
+ 			offset_in_line = len;
+ 		} else
+ #endif /*MULTIBYTE*/
  		/*
  		 * Only display up to the right-hand column.  Set a flag if
  		 * the entire character wasn't displayed for use in setting
***************
*** 379,384 ****
--- 531,540 ----
  			*yp = smp - HMAP;
  			if (F_ISSET(sp, SC_TINPUT))
  				*xp = scno - chlen;
+ #ifdef MULTIBYTE
+ 			else if (!multi_isnone(sp, ch))
+ 				*xp = scno - chlen;
+ #endif /*MULTIBYTE*/
  			else
  				*xp = scno - 1;
  			if (O_ISSET(sp, O_NUMBER) &&
***************
*** 391,398 ****
  		}
  
  		/* If the line is on the screen, don't display anything. */
! 		if (is_cached)
  			continue;
  
  #define	FLUSH {								\
  	*cbp = '\0';							\
--- 547,560 ----
  		}
  
  		/* If the line is on the screen, don't display anything. */
! 		if (is_cached) {
! #ifdef MULTIBYTE
! 			offset_in_line += (KEY_BLEN(sp, ch) - 1);
! 			if (fakeeol)
! 				scno = cols_per_screen;
! #endif /*MULTIBYTE*/
  			continue;
+ 		}
  
  #define	FLUSH {								\
  	*cbp = '\0';							\
***************
*** 413,423 ****
--- 575,622 ----
  				*cbp++ = TABCH;
  			}
  		else {
+ #ifndef MULTIBYTE
  			if (cbp + chlen >= ecbp)
  				FLUSH;
  			for (kp = KEY_NAME(sp, ch) + offset_in_char; chlen--;)
  				*cbp++ = *kp++;
+ #else
+ 			if (1 < KEY_BLEN(sp, ch)) {
+ 				if (offset_in_char)
+ 					kp = "          ";	/*enough?*/
+ 				else {
+ 					/*
+ 					 * Leave multibyte chars as is.
+ 					 * In this case, actual chars emitted
+ 					 * to screen library is not the same
+ 					 * as its width!  Be careful.
+ 					 */
+ 					kp = multi_rawname(sp, pch);
+ 					chlen = strlen(kp);
+ 				}
+ 			} else
+ 				kp = KEY_NAME(sp, ch) + offset_in_char;
+ 			if (cbp + chlen >= ecbp)
+ 				FLUSH;
+ 			while (chlen--)
+ 				*cbp++ = *kp++;
+ 			if (fakeeol) {
+ 				/*
+ 				 * XXX
+ 				 * Is it a good idea to fill with spaces?
+ 				 * mule uses backslash.
+ 				 */
+ 				while (scno < cols_per_screen) {
+ 					*cbp++ = ' ';
+ 					scno++;
+ 				}
+ 			}
+ #endif /*MULTIBYTE*/
  		}
+ 
+ #ifdef MULTIBYTE
+ 		offset_in_line += (KEY_BLEN(sp, ch) - 1);
+ #endif
  	}
  
  	if (scno < cols_per_screen) {
Index: vi/vs_msg.c
Prereq: 	10.77 
*** nvi-1.79/vi/vs_msg.c	Mon Oct 14 03:25:23 1996
--- nvi-1.79-m17n/vi/vs_msg.c	Thu Mar 27 13:31:27 1997
***************
*** 39,45 ****
--- 39,49 ----
  
  static void	vs_divider __P((SCR *));
  static void	vs_msgsave __P((SCR *, mtype_t, char *, size_t));
+ #ifndef MULTIBYTE
  static void	vs_output __P((SCR *, mtype_t, const char *, int));
+ #else
+ static void	vs_output __P((SCR *, mtype_t, const CHAR_T *, int));
+ #endif
  static void	vs_scroll __P((SCR *, int *, sw_t));
  static void	vs_wait __P((SCR *, int *, sw_t));
  
***************
*** 225,237 ****
--- 229,249 ----
   * alternate method of displaying messages, e.g. dialog boxes, should set their
   * scr_msg function to the correct function before calling the editor.
   *
+  * PUBLIC: #ifndef MULTIBYTE
   * PUBLIC: void vs_msg __P((SCR *, mtype_t, char *, size_t));
+  * PUBLIC: #else
+  * PUBLIC: void vs_msg __P((SCR *, mtype_t, CHAR_T *, size_t));
+  * PUBLIC: #endif
   */
  void
  vs_msg(sp, mtype, line, len)
  	SCR *sp;
  	mtype_t mtype;
+ #ifndef MULTIBYTE
  	char *line;
+ #else
+ 	CHAR_T *line;
+ #endif
  	size_t len;
  {
  	GS *gp;
***************
*** 289,295 ****
--- 301,338 ----
  
  		if (mtype == M_ERR)
  			(void)gp->scr_attr(sp, SA_INVERSE, 1);
+ #ifndef MULTIBYTE
  		(void)printf("%.*s", (int)len, line);
+ #else
+ 	    {
+ 		size_t i, j;
+ 		CHAR_T *p;
+ 		
+ 		i = 0;
+ 		while (i < len) {
+ 			/* output non multibyte chars in bulk */
+ 			j = 0;
+ 			while (i + j < len && KEY_BLEN(sp, line[i + j]) == 1)
+ 				j++;
+ 			if (j) {
+ 				(void)printf("%.*s", (int)j, &line[i]);
+ 				i += j;
+ 			}
+ 
+ 			/*
+ 			 * output single multibyte char
+ 			 * XXX quickhack
+ 			 */
+ 			if (i < len && 1 < KEY_BLEN(sp, line[i])) {
+ 				p = multi_name(sp, &line[i]);
+ 				(void)printf("%.*s", strlen(p), p);
+ 				if (p[0] == '\033')
+ 					(void)printf("\033(B");
+ 				i += KEY_BLEN(sp, line[i]);
+ 			}
+ 		}
+ 	    }
+ #endif /*MULTIBYTE*/
  		if (mtype == M_ERR)
  			(void)gp->scr_attr(sp, SA_INVERSE, 0);
  		(void)fflush(stdout);
***************
*** 397,413 ****
--- 440,471 ----
  vs_output(sp, mtype, line, llen)
  	SCR *sp;
  	mtype_t mtype;
+ #ifndef MULTIBYTE
  	const char *line;
+ #else
+ 	const CHAR_T *line;
+ #endif
  	int llen;
  {
  	CHAR_T *kp;
  	GS *gp;
  	VI_PRIVATE *vip;
  	size_t chlen, notused;
+ #ifndef MULTIBYTE
  	int ch, len, rlen, tlen;
  	const char *p, *t;
+ #else
+ 	int len, rlen, tlen;
+ 	CHAR_T ch;
+ 	const CHAR_T *p, *t;
+ 	size_t blen;
+ 	size_t scrlen;
+ #endif
  	char *cbp, *ecbp, cbuf[128];
  
+ #ifdef CANNA
+ 	canna_modelinesw(sp, 0);
+ #endif
  	gp = sp->gp;
  	vip = VIP(sp);
  	for (p = line, rlen = llen; llen > 0;) {
***************
*** 417,428 ****
--- 475,495 ----
  		else
  			len = p - line;
  
+ #ifndef MULTIBYTE
  		/*
  		 * The max is sp->cols characters, and we may have already
  		 * written part of the line.
  		 */
  		if (len + vip->lcontinue > sp->cols)
  			len = sp->cols - vip->lcontinue;
+ #else
+ 		/*
+ 		 * Single byte code assumes that, every byte occupies
+ 		 * single column.  In multibyte environment, it is not true.
+ 		 * We check screen width separately from the string length.
+ 		 */
+ 		scrlen = sp->cols - vip->lcontinue;
+ #endif /*MULTIBYTE*/
  
  		/*
  		 * If the first line output, do nothing.  If the second line
***************
*** 471,476 ****
--- 538,544 ----
  	cbp = cbuf;							\
  }
  		ecbp = (cbp = cbuf) + sizeof(cbuf) - 1;
+ #ifndef MULTIBYTE
  		for (t = line, tlen = len; tlen--; ++t) {
  			ch = *t;
  			/*
***************
*** 488,493 ****
--- 556,609 ----
  			for (kp = KEY_NAME(sp, ch); chlen--;)
  				*cbp++ = *kp++;
  		}
+ #else
+ 		t = line;
+ 		tlen = len;
+ 		while (0 < tlen && 0 < scrlen) {
+ 			ch = *t;
+ 			/*
+ 			 * Replace tabs with spaces, there are places in
+ 			 * ex that do column calculations without looking
+ 			 * at <tabs> -- and all routines that care about
+ 			 * <tabs> do their own expansions.  This catches
+ 			 * <tabs> in things like tag search strings.
+ 			 */
+ 			if (ch == '\t')
+ 				ch = ' ';
+ 
+ 			chlen = KEY_LEN(sp, ch);
+ 			blen = KEY_BLEN(sp, ch);
+ 			if (1 < blen) {
+ 				/*
+ 				 * we transmit characters without conversion.
+ 				 */
+ 				kp = multi_rawname(sp, t);
+ 				chlen = blen;
+ 
+ 				/* chlen is modified, don't use that */
+ 				if (tlen < blen)
+ 					break;
+ 				if (scrlen < KEY_LEN(sp, ch))
+ 					break;
+ 				t += blen;
+ 				tlen -= blen;
+ 				scrlen -= KEY_LEN(sp, ch);
+ 			} else {
+ 				kp = KEY_NAME(sp, ch);
+ 
+ 				if (scrlen < chlen)
+ 					break;
+ 				t++;
+ 				tlen--;
+ 				scrlen -= chlen;
+ 			}
+ 
+ 			if (cbp + chlen >= ecbp)
+ 				FLUSH;
+ 			while (chlen--)
+ 				*cbp++ = *kp++;
+ 		}
+ #endif /*MULTIBYTE*/
  		if (cbp > cbuf)
  			FLUSH;
  		if (mtype == M_ERR)
***************
*** 500,511 ****
--- 616,636 ----
  		vip->lcontinue = 0;
  
  		/* Reset for the next line. */
+ #ifndef MULTIBYTE
  		line += len;
  		llen -= len;
  		if (p != NULL) {
  			++line;
  			--llen;
  		}
+ #else
+ 		llen -= (t - line);
+ 		line = t;
+ 		if (tlen == 0 && p != NULL) {
+ 			++line;
+ 			--llen;
+ 		}
+ #endif /*MULTIBYTE*/
  	}
  
  	/* Set up next continuation line. */
Index: vi/vs_refresh.c
Prereq: 	10.44 
*** nvi-1.79/vi/vs_refresh.c	Tue Oct 15 01:12:08 1996
--- nvi-1.79-m17n/vi/vs_refresh.c	Thu Mar 27 13:17:20 1997
***************
*** 30,36 ****
--- 30,38 ----
  #define	UPDATE_CURSOR	0x01			/* Update the cursor. */
  #define	UPDATE_SCREEN	0x02			/* Flush to screen. */
  
+ #ifndef CANNA
  static void	vs_modeline __P((SCR *));
+ #endif
  static int	vs_paint __P((SCR *, u_int));
  
  /*
***************
*** 139,144 ****
--- 141,149 ----
  		if (F_ISSET(tsp, SC_STATUS)) {
  			need_refresh = 1;
  			vs_resolve(tsp, sp, 0);
+ #ifdef CANNA
+ 			canna_modelinesw(sp, 0);
+ #endif
  		}
  	if (need_refresh)
  		(void)gp->scr_refresh(sp, 0);
***************
*** 171,178 ****
--- 176,194 ----
  	VI_PRIVATE *vip;
  	recno_t lastline, lcnt;
  	size_t cwtotal, cnt, len, notused, off, y;
+ #ifndef MULTIBYTE
  	int ch, didpaint, isempty, leftright_warp;
  	char *p;
+ #else
+ 	int didpaint, isempty, leftright_warp;
+ 	CHAR_T ch;
+ 	CHAR_T *p;
+ #endif /*MULTIBYTE*/
+ #ifdef MULTIBYTE
+ 	char *p0;
+ 
+ 	p = p0 = NULL;
+ #endif /*MULTIBYTE*/
  
  #define	 LNO	sp->lno			/* Current file line. */
  #define	OLNO	vip->olno		/* Remembered file line. */
***************
*** 466,471 ****
--- 482,490 ----
  			goto slow;
  		return (1);
  	}
+ #ifdef MULTIBYTE
+ 	p0 = p;
+ #endif
  
  #ifdef DEBUG
  	/* Sanity checking. */
***************
*** 481,486 ****
--- 500,506 ----
  	 * screen, and therefore, how many screen positions to move.
  	 */
  	if (CNO < OCNO) {
+ #ifndef MULTIBYTE
  		/*
  		 * 7a: Cursor moved left.
  		 *
***************
*** 532,538 ****
--- 552,632 ----
  		if (SCNO < cwtotal)
  			goto slow;
  		SCNO -= cwtotal;
+ #else
+ 		/*
+ 		 * 7a: Cursor moved left.
+ 		 *
+ 		 * The old cursor position can be past EOL if, for example,
+ 		 * we just deleted the rest of the line.
+ 		 * In this case, since we don't know the width of
+ 		 * the characters we traversed, we have to do it slowly.
+ 		 */
+ 		if (OCNO >= len)
+ 			goto slow;
+ 
+ 		/*
+ 		 * cwtotal acts as new value for SCNO.  Set cwtotal to the
+ 		 * first char for content on CNO byte, for ease handling
+ 		 * of wide characters.
+ 		 *
+ 		 * If the character we're stepping on lies across
+ 		 * cross a screen boundary, we have no hope to speed
+ 		 * it up.  Do it slowly.
+ 		 */
+ 		if (multi_isnone(sp, p0[OCNO])) {
+ 			if (p0[OCNO] == '\t')
+ 				goto slow;
+ 			if (SCNO + 1 < KEY_LEN(sp, p0[OCNO]))
+ 				goto slow;
+ 			cwtotal = SCNO + 1 - KEY_LEN(sp, p0[OCNO]);
+ 		} else
+ 			cwtotal = SCNO;
+ 		cnt = OCNO - CNO;
+ 
+ 		/*
+ 		 * Quick sanity check -- it's hard to figure out exactly when
+ 		 * we cross a screen boundary as we do in the cursor right
+ 		 * movement.  If cnt is so large that we're going to cross the
+ 		 * boundary no matter what, stop now.
+ 		 */
+ 		if (SCNO + 1 + MAX_CHARACTER_COLUMNS < cnt)
+ 			goto slow;
+ 
+ 		/*
+ 		 * Count up the widths of the characters.  If it's a tab
+ 		 * character, go do it the the slow way.
+ 		 */
+ 		while (cnt) {
+ 			size_t tlen;
+ 
+ 			tlen = multi_back(sp, p0, &p0[CNO + cnt]);
+ 			if (cnt < tlen)
+ 				goto slow;
+ 			cnt -= tlen;
+ 			if (*((u_char *)&p0[CNO + cnt]) == '\t')
+ 				goto slow;
+ 			tlen = KEY_LEN(sp, p0[CNO + cnt]);
+ 			if (cwtotal < tlen)
+ 				goto slow;
+ 			cwtotal -= tlen;
+ 		}
+ 
+ 		/*
+ 		 * If we're moving left, and there's a wide character in the
+ 		 * current position, go to the end of the character.
+ 		 */
+ 		if (1 < KEY_LEN(sp, p0[CNO + cnt])) {
+ 			if (multi_isnone(sp, p0[CNO + cnt]))
+ 				cwtotal += KEY_LEN(sp, p0[CNO + cnt]) - 1;
+ 		}
+ 
+ 		/*
+ 		 * At last, update the screen cursor.
+ 		 */
+ 		SCNO = cwtotal;
+ #endif /*MULTIBYTE*/
  	} else {
+ #ifndef MULTIBYTE
  		/*
  		 * 7b: Cursor moved right.
  		 *
***************
*** 562,567 ****
--- 656,724 ----
  		/* See screen change comment in section 6a. */
  		if (SCNO >= SCREEN_COLS(sp))
  			goto slow;
+ #else
+ 		/*
+ 		 * 7b: Cursor moved right.
+ 		 *
+ 		 * Point the character at the cursor.
+ 		 * cwtotal acts as new value for SCNO.  Set cwtotal to the
+ 		 * first char for content on CNO byte, for ease handling
+ 		 * of wide characters.
+ 		 */
+ 		if (OCNO >= len)
+ 			goto slow;
+ 
+ 		if (multi_isnone(sp, p[OCNO]))
+ 			cwtotal = SCNO + 1 - KEY_LEN(sp, p[OCNO]);
+ 		else
+ 			cwtotal = SCNO;
+ 
+ 		cnt = CNO - OCNO;
+ 		p = p + OCNO;
+ 
+ 		/*
+ 		 * Count up the widths of the characters.  If it's a tab
+ 		 * character, go do it the the slow way.
+ 		 * If a multibyte char seems to occupy the screen boundary,
+ 		 * that will be pushed to the next line.  Adjust the cursor
+ 		 * In that case.
+ 		 * If we cross a screen boundary, we can quit.
+ 		 */
+ 		while (cnt) {
+ 			ch = *(u_char *)p;
+ 			if (ch == '\t')
+ 				goto slow;
+ 			cnt -= KEY_BLEN(sp, ch);
+ 			p += KEY_BLEN(sp, ch);
+ 			cwtotal += KEY_LEN(sp, ch);
+ 			if (1 < KEY_BLEN(sp, *p)
+ 			 && cwtotal + KEY_LEN(sp, *p) >= SCREEN_COLS(sp))
+ 				cwtotal = SCREEN_COLS(sp);
+ 			if (cwtotal >= SCREEN_COLS(sp))
+ 				break;
+ 		}
+ 
+ 		/*
+ 		 * If we are on the tab character, we must do it slowly.
+ 		 * If we're on a wide character in the current position,
+ 		 * go to the end of the character.
+ 		 */
+ 		if (*p == '\t')
+ 			goto slow;
+ 		else if (1 < KEY_LEN(sp, *p)) {
+ 			if (multi_isnone(sp, *p))
+ 				cwtotal += KEY_LEN(sp, *p) - 1;
+ 		}
+ 
+ 		/*
+ 		 * At last, update the screen cursor.
+ 		 */
+ 		SCNO = cwtotal;
+ 
+ 		/* See screen change comment in section 6a. */
+ 		if (SCNO >= SCREEN_COLS(sp))
+ 			goto slow;
+ #endif /*MULTIBYTE*/
  	}
  
  	/*
***************
*** 590,600 ****
--- 747,781 ----
  	 * first screen as compared to subsequent ones.
  	 */
  	if (O_ISSET(sp, O_LEFTRIGHT)) {
+ #ifdef MULTIBYTE
+ 		size_t cnt0;
+ #endif
  		/*
  		 * Get the screen column for this character, and correct
  		 * for the number option offset.
  		 */
  		cnt = vs_columns(sp, NULL, LNO, &CNO, NULL);
+ #ifdef MULTIBYTE
+ 		cnt0 = cnt;
+ 		/*
+ 		 * For multibyte chars, we need to display the character
+ 		 * as a whole.  For that, we adjust the value returned by
+ 		 * vs_columns() by the width of the character, to check
+ 		 * for side scrolling possibility toward left.
+ 		 *
+ 		 * XXX
+ 		 * Dirty hack.
+ 		 */
+ 		if (!p) {
+ 			if (db_eget(sp, LNO, &p, &len, &isempty)) {
+ 				if (!isempty)
+ 					return (1);
+ 			}
+ 			p0 = p;
+ 		}
+ 		if (!multi_isnone(sp, p0[CNO]))
+ 			cnt -= KEY_LEN(sp, p0[CNO]);
+ #endif /*MULTIBYTE*/
  		if (O_ISSET(sp, O_NUMBER))
  			cnt -= O_NUMBER_LENGTH;
  
***************
*** 612,617 ****
--- 793,805 ----
  			goto shifted;
  		}
  
+ #ifdef MULTIBYTE
+ 		/*
+ 		 * To check for side scroll toward right, we need to use the
+ 		 * value returned by vs_columns(), not the adjusted one.
+ 		 */
+ 		cnt = cnt0;
+ #endif /*MULTIBYTE*/
  		/* Adjust the window towards the end of the line. */
  		if (off == 0 && off + SCREEN_COLS(sp) < cnt ||
  		    off != 0 && off + sp->cols < cnt) {
***************
*** 762,770 ****
--- 950,969 ----
   * vs_modeline --
   *	Update the mode line.
   */
+ #ifndef CANNA
  static void
  vs_modeline(sp)
  	SCR *sp;
+ #else
+ /*
+  * PUBLIC: #ifdef CANNA
+  * PUBLIC: void vs_modeline __P((SCR *));
+  * PUBLIC: #endif
+  */
+ void
+ vs_modeline(sp)
+ 	SCR *sp;
+ #endif
  {
  	static char * const modes[] = {
  		"215|Append",			/* SM_APPEND */
***************
*** 777,782 ****
--- 976,984 ----
  	size_t cols, curcol, curlen, endpoint, len, midpoint;
  	const char *t;
  	int ellipsis;
+ #ifdef MULTIBYTE
+ 	/* XXX p is ok to be char *, since p points to filename only. */
+ #endif
  	char *p, buf[20];
  
  	gp = sp->gp;
***************
*** 796,803 ****
--- 998,1014 ----
  	 */
  	(void)gp->scr_move(sp, LASTLINE(sp), 0);
  
+ #ifdef CANNA
+ 	curlen = canna_modeline(sp);
+ 	canna_modelinesw(sp, 1);
+ 	if (sp->cols - 1 < curlen)
+ 		return;
+ #endif /*CANNA*/
+ 
  	/* If more than one screen in the display, show the file name. */
+ #ifndef CANNA
  	curlen = 0;
+ #endif
  	if (IS_SPLIT(sp)) {
  		for (p = sp->frp->name; *p != '\0'; ++p);
  		for (ellipsis = 0, cols = sp->cols / 2; --p > sp->frp->name;) {
Index: vi/vs_relative.c
Prereq: 	10.11 
*** nvi-1.79/vi/vs_relative.c	Mon May 13 23:20:04 1996
--- nvi-1.79-m17n/vi/vs_relative.c	Fri Feb 21 22:34:20 1997
***************
*** 108,129 ****
  	size_t *cnop, *diffp;
  {
  	size_t chlen, cno, curoff, last, len, scno;
  	int ch, leftright, listset;
  	char *p;
  
  	/* Need the line to go any further. */
! 	if (lp == NULL) {
  		(void)db_get(sp, lno, 0, &lp, &len);
- 		if (len == 0)
- 			goto done;
- 	}
- 
- 	/* Missing or empty lines are easy. */
- 	if (lp == NULL) {
- done:		if (diffp != NULL)		/* XXX */
- 			*diffp = 0;
- 		return (0);
- 	}
  
  	/* Store away the values of the list and leftright edit options. */
  	listset = O_ISSET(sp, O_LIST);
--- 108,125 ----
  	size_t *cnop, *diffp;
  {
  	size_t chlen, cno, curoff, last, len, scno;
+ #ifndef MULTIBYTE
  	int ch, leftright, listset;
  	char *p;
+ #else
+ 	int leftright, listset;
+ 	CHAR_T ch;
+ 	CHAR_T *p;
+ #endif /*MULTIBYTE*/
  
  	/* Need the line to go any further. */
! 	if (lp == NULL)
  		(void)db_get(sp, lno, 0, &lp, &len);
  
  	/* Store away the values of the list and leftright edit options. */
  	listset = O_ISSET(sp, O_LIST);
***************
*** 140,145 ****
--- 136,148 ----
  	if (O_ISSET(sp, O_NUMBER))
  		scno += O_NUMBER_LENGTH;
  
+ 	/* Missing or empty lines are easy. */
+ 	if (len == 0 || lp == NULL) {
+ 		if (diffp != NULL)		/* XXX */
+ 			*diffp = 0;
+ 		return (scno);
+ 	}
+ 
  	/* Macro to return the display length of any signal character. */
  #define	CHLEN(val) (ch = *(u_char *)p++) == '\t' &&			\
  	    !listset ? TAB_OFF(val) : KEY_LEN(sp, ch);
***************
*** 161,173 ****
--- 164,220 ----
  			curoff -= sp->cols;				\
  }
  	if (cnop == NULL)
+ #ifndef MULTIBYTE
  		while (len--) {
  			chlen = CHLEN(curoff);
  			last = scno;
  			scno += chlen;
  			TAB_RESET;
  		}
+ #else
+ 	    {
+ 		/* len designates bytes/line. */
+ 		int mb;
+ 		int ml;
+ 		while (0 < len) {
+ 			if (1 < KEY_BLEN(sp, *p)) {
+ 				mb = KEY_BLEN(sp, *p);
+ 				ml = KEY_LEN(sp, *p);
+ 				if (len < mb)
+ 					break;
+ 				ch = *p;
+ 				chlen = ml;
+ 				last = scno;
+ 				scno += ml;
+ 				len -= mb;
+ 				p += mb;
+ 				
+ 				/* TAB_RESET is expanded here. */
+ 				curoff += chlen;
+ 				if (!leftright && curoff >= sp->cols) {
+ 					if (ch == '\t') {
+ 						curoff = 0;
+ 						scno -= scno % sp->cols;
+ 					} else {
+ 						if (curoff == sp->cols)
+ 							curoff = 0;
+ 						else
+ 							curoff = chlen;
+ 					}
+ 				}
+ 			} else {
+ 				chlen = CHLEN(curoff);
+ 				last = scno;
+ 				scno += chlen;
+ 				len--;
+ 				/* p will be modified in CHLEN() */
+ 				TAB_RESET;
+ 			}
+ 		}
+ 	    }
+ #endif /*MULTIBYTE*/
  	else
+ #ifndef MULTIBYTE
  		for (cno = *cnop;; --cno) {
  			chlen = CHLEN(curoff);
  			last = scno;
***************
*** 176,181 ****
--- 223,273 ----
  			if (cno == 0)
  				break;
  		}
+ #else
+ 	    {
+ 		int mb;
+ 		int ml;
+ 		cno = *cnop;
+ 		while (1) {
+ 			if (1 < KEY_BLEN(sp, *p)) {
+ 				mb = KEY_BLEN(sp, *p);
+ 				ml = KEY_LEN(sp, *p);
+ 				ch = *p;
+ 				chlen = ml;
+ 				last = scno;
+ 				scno += ml;
+ 				p += mb;
+ 
+ 				/* TAB_RESET is expanded here. */
+ 				curoff += chlen;
+ 				if (!leftright && curoff >= sp->cols) {
+ 					if (ch == '\t') {
+ 						curoff = 0;
+ 						scno -= scno % sp->cols;
+ 					} else {
+ 						if (curoff == sp->cols)
+ 							curoff = 0;
+ 						else
+ 							curoff = chlen;
+ 					}
+ 				}
+ 
+ 				if (cno < mb)
+ 					break;
+ 				cno -= mb;
+ 			} else {
+ 				chlen = CHLEN(curoff);
+ 				last = scno;
+ 				scno += chlen;
+ 				/* p will be modified in CHLEN() */
+ 				TAB_RESET;
+ 				if (cno == 0)
+ 					break;
+ 				cno--;
+ 			}
+ 		}
+ 	    }
+ #endif /*MULTIBYTE*/
  
  	/* Add the trailing '$' if the O_LIST option set. */
  	if (listset && cnop == NULL)
***************
*** 209,217 ****
--- 301,316 ----
  
  	/* Last character is easy, and common. */
  	if (islast) {
+ #ifndef MULTIBYTE
  		if (db_get(sp, lno, 0, NULL, &len) || len == 0)
  			return (0);
  		return (len - 1);
+ #else
+ 		CHAR_T *p;
+ 		if (db_get(sp, lno, 0, &p, &len) || len == 0)
+ 			return (0);
+ 		return (len - multi_back(sp, p, &p[len]));
+ #endif /*MULTIBYTE*/
  	}
  
  	/* First character is easy, and common. */
***************
*** 228,233 ****
--- 327,339 ----
   *
   * PUBLIC: size_t vs_colpos __P((SCR *, recno_t, size_t));
   */
+ #ifdef MULTIBYTE
+ /*
+  * XXX
+  * note that the third argument, cno, designate column on the screen, not
+  * the offset from the head of the buffer.
+  */
+ #endif /*MULTIBYTE*/
  size_t
  vs_colpos(sp, lno, cno)
  	SCR *sp;
***************
*** 235,242 ****
--- 341,354 ----
  	size_t cno;
  {
  	size_t chlen, curoff, len, llen, off, scno;
+ #ifndef MULTIBYTE
  	int ch, leftright, listset;
  	char *lp, *p;
+ #else
+ 	int leftright, listset;
+ 	CHAR_T ch;
+ 	CHAR_T *lp, *p;
+ #endif /*MULTIBYTE*/
  
  	/* Need the line to go any further. */
  	(void)db_get(sp, lno, 0, &lp, &llen);
***************
*** 253,267 ****
  	off = cno / sp->cols;
  	cno %= sp->cols;
  	for (scno = 0, p = lp, len = llen; off--;) {
  		for (; len && scno < sp->cols; --len)
  			scno += CHLEN(scno);
  
  		/*
  		 * If reached the end of the physical line, return the last
  		 * physical character in the line.
  		 */
! 		if (len == 0)
  			return (llen - 1);
  
  		/*
  		 * If folding screens (the historic vi screen format), past
--- 365,437 ----
  	off = cno / sp->cols;
  	cno %= sp->cols;
  	for (scno = 0, p = lp, len = llen; off--;) {
+ #ifndef MULTIBYTE
  		for (; len && scno < sp->cols; --len)
  			scno += CHLEN(scno);
+ #else
+ 	    {
+ 		size_t mb;
+ 		size_t ml;
+ 		int ch0;
+ 
+ 		ch0 = ch = p[0];	/*for safety*/
+ 		while (len && scno < sp->cols) {
+ 			ch0 = ch;
+ 			ch = p[0];
+ 			if (ch == '\t' && !listset) {
+ 				scno += TAB_OFF(scno);
+ 				len--;
+ 				p++;
+ 				continue;
+ 			}
+ 			
+ 			mb = KEY_BLEN(sp, ch);
+ 			ml = KEY_LEN(sp, ch);
+ 			if (mb == 1 || scno + ml < sp->cols) {
+ 				/*
+ 				 * Singlebyte char can be displayed across
+ 				 * the end-of-screen.
+ 				 * If a multibyte char fits into this line,
+ 				 * put it here.
+ 				 */
+ 				scno += ml;
+ 				len -= mb;
+ 				p += mb;
+ 			} else if (leftright) {
+ 				/*
+ 				 * side-scrolling screen is similar to
+ 				 * singlebyte case.
+ 				 */
+ 				scno += ml;
+ 				len -= mb;
+ 				p += mb;
+ 			} else {
+ 				/*
+ 				 * Multibyte char can't be displayed across
+ 				 * the end-of-screen, in folding screen.
+ 				 * If it crosses the end-of-screen,
+ 				 * don't put it here.
+ 				 * Put it on the next line.
+ 				 * we must adjust ch to the last char of the
+ 				 * line.
+ 				 */
+ 				scno = sp->cols;
+ 			}
+ 		}
+ 	    }
+ #endif /*MULTIBYTE*/
  
  		/*
  		 * If reached the end of the physical line, return the last
  		 * physical character in the line.
  		 */
! 		if (len == 0) {
! #ifndef MULTIBYTE
  			return (llen - 1);
+ #else
+ 			return (llen - multi_back(sp, lp, &lp[llen]));
+ #endif
+ 		}
  
  		/*
  		 * If folding screens (the historic vi screen format), past
***************
*** 277,283 ****
--- 447,471 ----
  
  	/* Step through the line until reach the right character or EOL. */
  	for (curoff = scno; len--;) {
+ #ifndef MULTIBYTE
  		chlen = CHLEN(curoff);
+ #else
+ 	    {
+ 		size_t mb;
+ 		size_t ml;
+ 		mb = KEY_BLEN(sp, *p);
+ 		ml = KEY_LEN(sp, *p);
+ 		if (*p == '\t' && !listset) {
+ 			chlen = TAB_OFF(curoff);
+ 			/* len will be modified in for loop */
+ 			p++;
+ 		} else {
+ 			chlen = ml;
+ 			len -= (mb - 1);
+ 			p += mb;
+ 		}
+ 	    }
+ #endif /*MULTIBYTE*/
  
  		/*
  		 * If we've reached the specific character, there are three
***************
*** 293,305 ****
--- 481,509 ----
  		 */
  		if ((scno += chlen) >= cno) {
  			off = p - lp;
+ #ifndef MULTIBYTE
  			return (scno == cno ?
  			    (off < llen - 1 ? off : llen - 1) : off - 1);
+ #else
+ 			if (scno == cno) {
+ 				size_t lastlen;
+ 				lastlen = llen - multi_back(sp, lp, &lp[llen]);
+ 				if (off < lastlen)
+ 					return off;
+ 				else
+ 					return lastlen;
+ 			} else
+ 				return off - multi_back(sp, lp, &lp[off]);
+ #endif /*MULTIBYTE*/
  		}
  
  		TAB_RESET;
  	}
  
  	/* No such character; return the start of the last character. */
+ #ifndef MULTIBYTE
  	return (llen - 1);
+ #else
+ 	return llen - multi_back(sp, lp, &lp[llen]);
+ #endif
  }
